program DELICa;
const
  noE=24;
  no_exp=4;
  maxBuf=(noE*(no_exp+1)*(no_exp+1)*noE)+noE+1000;
  baseE24: array [1..noE] of longint =(10,11,12,13,15,16,18,20,22,24,27,30,33,36,39,43,47,51,56,62,68,75,82,91);

type
  Tconnection=(_par,_ser);
  Tcell= record
          v:single;
          pwrv:single; { value of R for max. power disipation }
                       { paralell connection = Rmin
                         serial connection = Rmax }
          cn:Tconnection;
          c:string; { internal connection }
         end;

  Txset = record
          c:longint; { # of cells }
          s:array[0..maxBuf] of Tcell;
         end;
  Tset = ^Txset;
  TptrStr = ^string;
var
  { }
  ex: word;
  Rset:Tset;
  tmp1,tmp2:Tset;
  i,j:longint;
  Trc,T:single;
  stp:byte;
  f1,f0:text;
  it,inV,outV,accu,Vo,Vol,Ri,Rload,r,p1,p2,maxPwr:single;
  s1,s2: TptrStr;
  k11,k22,k12,k21:longint;
  Rimax,Rimin:single;

procedure derive(var inset:Tset;connection:Tconnection;var x:Tset);
var
  i,n,j:longint;
begin
  x^.c:=0;
  for i:=0 to maxBuf do begin
    x^.s[i].v:=0;
    x^.s[i].c:='';
  end;
  for i:=0 to inset^.c-1 do begin
    for n:=i to inset^.c-1 do begin
      case connection of
       _par: begin
               if inset^.s[i].v>0 then
                 x^.s[x^.c].v:= 1/((1/inset^.s[n].v)+(1/inset^.s[i].v))
               else x^.s[x^.c].v:=0;
               x^.s[x^.c].c:= '('+ inset^.s[n].c + '||' + inset^.s[i].c +')';

               if inset^.s[n].v>=inset^.s[i].v then
                 x^.s[x^.c].pwrv:=inset^.s[i].v
               else
                 x^.s[x^.c].pwrv:=inset^.s[n].v;

               x^.s[x^.c].cn:=_par;
               inc(x^.c);
               if x^.c>maxBuf then begin
                 writeln('too much elements/cells');
                 dispose(Rset);
                 halt(1);
               end;
             end;
       _ser: begin
               x^.s[x^.c].v:= inset^.s[n].v+inset^.s[i].v;
               x^.s[x^.c].c:= '('+ inset^.s[n].c + '-'+ inset^.s[i].c +')';

               if inset^.s[n].v>=inset^.s[i].v then
                 x^.s[x^.c].pwrv:=inset^.s[n].v
               else
                 x^.s[x^.c].pwrv:=inset^.s[i].v;
               x^.s[x^.c].cn:=_ser;
               inc(x^.c);
               if x^.c>maxBuf then begin
                 writeln('too much elements/cells');
                 dispose(Rset);
                 halt(1);
               end;
             end;
      end;
    end;
  end;
end;

procedure union(var x,y:Tset); { X:= X U Y }
var
  i,j:longint;
begin
  i:= x^.c;
  for j:=0 to y^.c-1 do begin
    x^.s[j+i]:= y^.s[j];
    inc(x^.c);
    if x^.c>maxBuf then begin
      writeln('too much elemnts/cells'); halt(1);
    end;
  end;
end;

procedure add_R(ival:longint);
begin
  Rset^.s[Rset^.c].v:= ival;
  str(ival,Rset^.s[Rset^.c].c);
  Rset^.s[Rset^.c].pwrv:=ival;
  Rset^.s[Rset^.c].cn:= _ser;
  inc(Rset^.c);
end;

begin

  writeln('enter input voltage[V]');
  readln(inV);
  writeln('enter output voltage[V]');
  readln(outV);
  writeln('enter accuracy[-] 1=100%');
  readln(accu);
  writeln('enter Rload, default=35kOhms [kOhms]');
  readln(Rload);
  writeln('enter max. power disipation default=0.125W [W]');
  readln(maxPwr);
  writeln('enter internal MAXimum resistance [Ohms]');
  readln(Rimax);
  writeln('enter internal MINimum resistance [Ohms]');
  readln(Rimin);

  new(Rset);
  { fill pwrv values at single element }
  Rset^.c:=0;


  for j:= 1 to noE do begin
    ex:=1;
    for i:=0 to no_exp do begin
      add_R(baseE24[j]*ex);
      ex:=ex*10;
    end;
  end;



  {$I-}
  assign(f0,'rcon.txt');
  rewrite(f0);
  if IOResult<>0 then begin writeln('can''t create ouput file'); halt(1); end;
  writeln(f0,'input voltage:', inV:3:2,' output voltage:', outV:3:2);
  writeln(f0,'baseline set: R(-E12 <100,8k2>');
  {$I+}

  { derived parallel & serial }


  new(tmp1);
  new(tmp2);

  writeln('DERIVING...');
  derive(Rset,_par,tmp1);
  derive(Rset,_ser,tmp2);
  union(Rset,tmp2);
  union(Rset,tmp1);

  dispose(tmp1);
  dispose(tmp2);

{  for i:=0 to Rset^.c-1 do
    writeln('R:',Rset^.s[i].v:3:2,' con:',Rset^.s[i].c);}


  { find best R-R log 1 }
  stp:=0;
  for i:=0 to Rset^.c-1 do begin { upper R }
    writeln((100*i/Rset^.c):3:1, 'DONE');

    for j:=0 to Rset^.c-1 do begin { lower R }
      Vo:= (inV*Rset^.s[j].v)/(Rset^.s[j].v+Rset^.s[i].v);
      if (((Vo-outV)/outV)<=accu) then begin
        r:= 1/((1/Rset^.s[j].v) + (1/(Rload*1000)));
        Vol:= (inV*r)/(r+Rset^.s[i].v);
        if (((Vol-outV)/outV)>=((-1)*accu)) then begin
          Ri:= 1/((1/Rset^.s[j].v)+(1/Rset^.s[i].v));
          it:= inV/(Rset^.s[j].v+Rset^.s[i].v);

          { Rlower }
          if Rset^.s[j].cn=_par then p1:= (Vo*Vo)/Rset^.s[j].pwrv;
          if Rset^.s[j].cn=_ser then p1:= it*it*Rset^.s[j].pwrv;
          { Rupper }
          if Rset^.s[i].cn=_par then p2:= sqr(inV-Vo)/Rset^.s[i].pwrv;
          if Rset^.s[i].cn=_ser then p2:= it*it*Rset^.s[i].pwrv;

              { v out }

         if (p1<maxPwr) and (p2<maxPwr) and (ri>Rimin) and (ri<Rimax) then begin
           s1:=addr(rset^.s[i].c);
           s2:=addr(rset^.s[j].c);
{writeln('UpperR', s1^,' LowerR', s2^,' Vo=',Vo:2:3,'V  Voload=',Vol:2:3,'V  Id=', (it*1000):4:2,' Ri:',Ri:2:3);}
writeln(f0,'UpperR', s1^,' LowerR', s2^,' Vo=',Vo:2:3,'V  Voload=',Vol:2:3,'V  Id=', (it*1000):4:6, ' Ri:',Ri:2:3);
{        inc(stp);
        if stp>22 then begin writeln('press enter to continue'); readln; stp:=0; end;}
         end;
        end;
      end;
    end;
  end;


  close(f0);
  dispose(Rset);
  writeln('programmed by Async, http://asyncbrain.baf.cz, distribute without limits with GNU recommendations.');
end.